/*-----------------------------------------------------------------------

File  : lexemetable.h

Author: Stephan Schulz (schulz@eprover.org)

Contents
 
  Table for maintaining lexemes of the parser.

  Copyright 2016 by the author.
  This code is released under the GNU General Public Licence.

Changes

<1> Mon Mar 28 19:43:02 CEST 2016
    New

-----------------------------------------------------------------------*/

#ifndef LEXEMETABLE

#define LEXEMETABLE

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <assert.h>


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

#define LEX_TABLE_INITIAL_SIZE 128

typedef struct 
{
   size_t size;
   int    next_entry;
   char   **table;
}LexTable, *LexTable_p;



/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

extern LexTable lextable;

void  LexTableFree(LexTable_p table);
char* LexTableAddLexeme(LexTable_p table, char* lexeme);


#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





